var async = require('../lib');
var expect = require('chai').expect;

describe('timeout', function () {

    it('timeout with series', function(done){
        async.series([
            async.timeout(function asyncFn(callback) {
                setTimeout(function() {
                    callback(null, 'I didn\'t time out');
                }, 50);
            }, 200),
            async.timeout(function asyncFn(callback) {
                setTimeout(function() {
                    callback(null, 'I will time out');
                }, 300);
            }, 150)
        ],
        function(err, results) {
            expect(err.message).to.equal('Callback function timed out.');
            expect(err.code).to.equal('ETIMEDOUT');
            expect(results[0]).to.equal('I didn\'t time out');
            done();
        });
    });

    it('timeout with parallel', function(done){
        async.parallel([
            async.timeout(function asyncFn(callback) {
                setTimeout(function() {
                    callback(null, 'I didn\'t time out');
                }, 50);
            }, 200),
            async.timeout(function asyncFn(callback) {
                setTimeout(function() {
                    callback(null, 'I will time out');
                }, 300);
            }, 150)
        ],
        function(err, results) {
            expect(err.message).to.equal('Callback function timed out.');
            expect(err.code).to.equal('ETIMEDOUT');
            expect(results[0]).to.equal('I didn\'t time out');
            done();
        });
    });

});
